ActiveAdmin.register Publication do
  menu  priority: 7,
        parent: I18n.t('activerecord.models.content_management'),
        if: proc{can?(:update, Publication)}
  # menu false

  batch_action :destroy, false
  config.paginate = false
  config.clear_action_items!
  config.clear_sidebar_sections!

  index :download_links => false do
    render :partial => "index"
  end

  controller do
    def index
      index! do |format|
        format.html # index.html.erb
        format.json { render json: { files: @publications.map{|publication| publication.to_jq_upload } } }
      end
    end

    def create
      if params["reorder_positions"]
        Publication.reorder_positions params['ids_order']

        respond_to do |format|
          format.json { render json: {
            success: true,
            message: I18n.t("notices.ordered.success")
            }.to_json }
        end
      else
        unless params["publication"]["file"].blank?
          file = params["publication"]["file"]

          params["publication"].merge!({
                  title: file.original_filename,
                  content_type: file.content_type
                })
        end

        create! do |format|

          if @publication.save
            format.html { redirect_to admin_publication_path @publication }
            format.json { render json: { files: [@publication].map{|publication| publication.to_jq_upload } }, status: :created }
          else
            format.html { render action: "new" }
            format.json { render json: @publication.errors, status: :unprocessable_entity }
          end
        end
      end
    end

    def edit
      @publication = Publication.find(params[:id])
      render :layout => false, :partial => "form"
    end
  end
end
