# Função para validar campos utilizando o x-editable
window.required = (value) ->
  return 'Este campo é obrigatório' if $.trim(value) == ""

jQuery ->
  #### Selectores
  publications_container  = $('.fileuploads-container')
  file_selector           = $('#file_selector', publications_container)
  auto_save               = $('#auto_save', file_selector)
  auto_save_checkbox      = $(':checkbox', auto_save)
  fileupload_form         = $('#fileupload:first'     , publications_container)
  files_container     = $('#upload_container .files'  , publications_container)
  action                  = file_selector.prop('action') || file_selector.prop('href')
  #### end Selectores

  # Core Functions
  # renderFiles - Renderiza os itens
  renderFiles = (data = {}, container = $(), offset, onload = false) ->
    template  = tmpl "template-download", files: data
    temp_itens  = $("<div />").append(template).children()

    if temp_itens.length
      temp_itens.each (o, ix) ->
        _t = $(this)
        _r = container.find("##{this.id}")

        if _r.length
          _r.replaceWith _t
        else
          container.append _t
          unless (onload)
            _savePositions()
    else
      container.append template

    container.children().addClass('in')
    _sortable(container).data()

  # Renderiza o formulário de edição.
  _renderEdit = (ev) ->
    ev.preventDefault()
    currentTarget   = $(ev.currentTarget)
    delegateTarget  = $(ev.delegateTarget)
    viewPort        = _checkOrCreateViewPort()
    container       = $('.container:first', viewPort)
    overlayItem     = $('<div class="row overlay-item"></div>')

    overlayItem.load currentTarget.prop('href'), () ->
      _t = $(this)

      # overlay_form = $('form', _t).data("remote", true)
      overlay_form = $('form', _t)
        .bind "submit", (ev) ->
          ev.preventDefault()
        .bind "ajax:complete", (ev, data) ->
          jData = eval("(#{data.responseText})")
          renderFiles jData.files, files_container
          _checkAndDestroyViewPort($(this))

      cancel = $('.btn.cancel', overlay_form).bind "click", (ev) ->
        ev.preventDefault()
        _checkAndDestroyViewPort($(this))

    .appendTo(container)

  # caso a viewPort não exista cria
  _checkOrCreateViewPort = ->
    viewPort = $('body .publication_edit_viewport')
    viewPort = if viewPort.length then viewPort else $("""
      <div class="publication_edit_viewport fade in overlay-viewport">
        <div class="overlay-block overlay-white"></div>
        <div class="publication_edit_container overlay-container"><div class="container"></div></div>
      </div>
""").appendTo($("body").css("overflow", "hidden"))

  _checkAndDestroyViewPort = (_4remove)->
    _4remove = $(_4remove)
    _4remove.closest('.overlay-item').remove() if _4remove.length

    viewPort = $('body .publication_edit_viewport')
    containerItens = $('.overlay-item', viewPort)
    if viewPort.length and !containerItens.length
      viewPort.removeClass('in').remove()
      $('body').css("overflow", "")

  # _sortable - Jquery UI para ordenação de itens
  _sortable = (container) ->
    container.sortable('destroy') if container.data("sortable")

    container
      .sortable
        handle: ".checkbox-container"
        # placeholder: "ui-state-highlight ui-sortable-placeholder template-download span3 fade in"
        opacity: 0.6
        revert: true
        stop: (ev, ui) ->
          _savePositions()
      .disableSelection()

  # Grava a ordenação no DB
  _savePositions = () ->
    $(".ids_order", file_selector).remove()
    ids_order = $(".ids_order", fileupload_form).clone().appendTo(file_selector)
    file_selector.submit()

  #### end Core Functions

  # Renderiza os itens carregados do Banco de dados
  selectedData = files_container.data('load')
  if selectedData && $.isArray(selectedData.files)
    renderFiles selectedData.files, files_container, 0, true
  else
    _sortable files_container
  publications_itens      = $('tr', files_container)

  # Callbacks
  fileupload_form
    .bind "fileuploadcompleted", (e, data) ->
      _savePositions()

  publications_itens.on "click", ".edit, .save", (event) ->
    target = $(event.delegateTarget)
    buttons = $(".edit, .save", target).toggleClass("hidden")

    $('.enable-editable', target).editable('toggleDisabled')
  # end Callbacks
