class CreatePublications < ActiveRecord::Migration
  def up
    create_table :publications do |t|
      t.string :slug
      t.string :title
      t.text :description
      t.string :username
      t.string :language
      t.string :document
      t.string :document_name
      t.string :content_type
      t.string :width
      t.string :height
      t.string :view_mode
      t.boolean :auto_flip
      t.integer :auto_flip_time
      t.string :background
      t.string :layout
      t.boolean :wmode
      t.integer :position
      t.boolean :published, :default => false

      t.timestamps
    end

    add_index :publications, :title
    add_index :publications, :slug, :unique => true
    add_index :publications, :document, :unique => true

  end

  def dow
    remove_index :publications, :title
    remove_index :publications, :slug
    remove_index :publications, :document

    drop_table :publications
  end
end
